//+------------------------------------------------------------------+
//|                                                53 martingale.mq4 |
//|                                             www.ForexRobots.info |
//|                                             www.ForexRobots.info |
//+------------------------------------------------------------------+
#property copyright "www.ForexRobots.info"
#property link      "www.ForexRobots.info"
#property version   "1.00"
#property strict
#include <stderror.mqh>
#include <stdlib.mqh>

extern string  tmp1              = "Short MA params";
extern double  S_ma_period       = 30;
extern int     S_ma_shift        = 0;

extern string  tmp2              = "Long MA params";
extern double  L_ma_period       = 50;
extern int     L_ma_shift        = 0;

extern string  tmp3              = "General params";
extern int     TimeFrame         = PERIOD_H4;
extern int     ma_method         = MODE_SMA;
extern int     ma_price          = PRICE_CLOSE;


extern int MaximumTrades = 10;
extern double StopLoss=50;
extern double TakeProfit=50;
extern double MartingaleAmount = 1.5;
extern bool UseSmartingale =true;
extern double   LotSize=0.1;
extern int MagicSeed=1000;
//input string  Password = "HolyGrail";

int magic;
double pips;
int tradeNumber;
string ScreenComment;
double martinlot;
double malot;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(UseSmartingale)
      MartingaleAmount=(StopLoss+TakeProfit)/TakeProfit;
      ScreenComment = "The Martingale is set to: " + DoubleToStr(MartingaleAmount,2);
      Comment(ScreenComment);
      
   magic = MagicNumberGenerator();
   
   pips =Point; //.00001 or .0001. .001 .01.
   if(Digits==3||Digits==5)
   pips*=10;
   


   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   LotsizeCalc();
   CheckForSignal();
  
  }
//+------------------------------------------------------------------+
//|                                 Check for signal                 |
//+------------------------------------------------------------------+
void CheckForSignal()
{
   static datetime candletime = 0;
   if(candletime != Time[0]){
   
double
   ms1 =iMA(Symbol(),TimeFrame,S_ma_period,S_ma_shift,ma_method,ma_price,1),
   ms2 =iMA(Symbol(),TimeFrame,S_ma_period,S_ma_shift,ma_method,ma_price,2),
   ml1 =iMA(Symbol(),TimeFrame,L_ma_period,L_ma_shift,ma_method,ma_price,1),
   ml2 =iMA(Symbol(),TimeFrame,L_ma_period,L_ma_shift,ma_method,ma_price,2);
   

   if(ms1>ml1 && ms2<ml2)
      EnterTrade(OP_BUY);
   if(ms1<ml1 && ms2>ml2)
      EnterTrade(OP_SELL);
candletime=Time[0];
   }
}

 
//+------------------------------------------------------------------+
//|                                 Lotsize                          |
//+------------------------------------------------------------------+
      
double LotsizeCalc()
      {  
         
          if(OrderSelect(lastTradeTicket(),MODE_HISTORY))        
            if(OrderProfit()<0 && tradeNumber <=MaximumTrades)
              {
               if(OrderLots()==0)
               martinlot = LotSize;
               
               else 
               martinlot = OrderLots();
               
               
               malot = martinlot * MartingaleAmount;
               tradeNumber++;
              }
            else
              {
              malot = LotSize;
              
              tradeNumber=1;
              }
            
            return(malot); 
     }    
      
//+------------------------------------------------------------------+
//|                                 Enter trade                      |
//+------------------------------------------------------------------+

void EnterTrade(int type){  
   int err=0;
   double price=Bid,
          sl=0, 
          tp=0;
          
   Comment(ScreenComment+"\nThis is trade number: "+(string)tradeNumber+"\nThe Lotsize is: "+DoubleToStr(LotsizeCalc(),2));
   if(type == OP_BUY)
      price =Ask;
   //----
   int ticket =  OrderSend(Symbol(),type,LotsizeCalc(),price,30,0,0,"1 ",magic,0,Magenta); 
   if(ticket>0){
      if(OrderSelect(ticket,SELECT_BY_TICKET)){
         sl = OrderOpenPrice()+(StopLoss*pips);
         if(StopLoss==0)sl=0;
         tp = OrderOpenPrice()-(TakeProfit*pips);
         if(OrderType()==OP_BUY){
            sl = OrderOpenPrice()-(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp = OrderOpenPrice()+(TakeProfit*pips);
         }
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
      }
      else{//in case it fails to select the order for some reason 
         Print("Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else{//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placement!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}

//+------------------------------------------------------------------+
//|Gets Ticket Number of this Ea's last closed trade.                |
//+------------------------------------------------------------------+
int lastTradeTicket(){
   int ticket = -1;
   for(int i=OrdersHistoryTotal()-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
               if(OrderMagicNumber()== magic){
               ticket = OrderTicket();
               break;               
          }
   }//for

   return(ticket);
   }
//+------------------------------------------------------------------+
//Total of ALL orders place by this expert.
//+------------------------------------------------------------------+
int TotalOpenOrders()
{
  int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber()== magic)
            total++;
	   }
	   else Print("Failed to select order",GetLastError());
	  }
	  return (total);
}
//+------------------------------------------------------------------+
//|                     MagicNumber                                  |
//+------------------------------------------------------------------+
int MagicNumberGenerator()
{
  	string mySymbol = StringSubstr(_Symbol,0,6);
   int pairNumber=0;
   int GeneratedNumber =0;   	
	     if (mySymbol == "AUDCAD") 	pairNumber=1;
	else if (mySymbol == "AUDCHF") 	pairNumber=2;
	else if (mySymbol == "AUDJPY") 	pairNumber=3;
	else if (mySymbol == "AUDNZD") 	pairNumber=4;
	else if (mySymbol == "AUDUSD") 	pairNumber=5;
	else if (mySymbol == "CADCHF") 	pairNumber=6;
	else if (mySymbol == "CADJPY") 	pairNumber=7;
	else if (mySymbol == "CHFJPY") 	pairNumber=8;
	else if (mySymbol == "EURAUD") 	pairNumber=9;
	else if (mySymbol == "EURCAD") 	pairNumber=10;
	else if (mySymbol == "EURCHF") 	pairNumber=11;
	else if (mySymbol == "EURGBP") 	pairNumber=12;
	else if (mySymbol == "EURJPY") 	pairNumber=13;
	else if (mySymbol == "EURNZD") 	pairNumber=14;
	else if (mySymbol == "EURUSD") 	pairNumber=15;
	else if (mySymbol == "GBPAUD") 	pairNumber=16;
	else if (mySymbol == "GBPCAD") 	pairNumber=17;
	else if (mySymbol == "GBPCHF") 	pairNumber=18;
	else if (mySymbol == "GBPJPY") 	pairNumber=19;
	else if (mySymbol == "GBPNZD") 	pairNumber=20;
	else if (mySymbol == "GBPUSD") 	pairNumber=21;
	else if (mySymbol == "NZDCAD") 	pairNumber=22;
	else if (mySymbol == "NZDJPY") 	pairNumber=23;
	else if (mySymbol == "NZDCHF") 	pairNumber=24;
	else if (mySymbol == "NZDUSD") 	pairNumber=25;
	else if (mySymbol == "USDCAD") 	pairNumber=26;
	else if (mySymbol == "USDCHF") 	pairNumber=27;
	else if (mySymbol == "USDJPY")	pairNumber=28;
	GeneratedNumber = MagicSeed + (pairNumber*10) + _Period;
	return(GeneratedNumber);
	}
//+------------------------------------------------------------------+
